pro vis_simulation, fn


@c_system.inc
@c_header.inc

start=systime(1)
close,/all
;stop
str=''
;fn='entry_2_938'
;fn='new_vims_test'

; entry site 1
;az=44.9			; 0-180   delta phi
;zen=24.62			; 0-90    mu

; entry site 2
;az=26.57
;zen=43.03

; entry site 3
;az=25.26
;zen=42.71


az=63.9
zen=31.3

az=180.-az

fn_vis='pixselh_mr14.sav'
;fn_ir='pixselhi_mr14.sav'

restore,'C:\idl\VIMS data\'+fn_vis

vimsspec_select=fltarr(96)
lat_select=fltarr(1)
long_select=fltarr(1)
phase_select=fltarr(1)
incidence_select=fltarr(1)
emission_select=fltarr(1)

x=0
for i=7,17 do begin
	vimsspec_select=vimsspec(i,0:95)+vimsspec_select
	lat_select=vimsspec(i,96)+lat_select
	long_select=vimsspec(i,97)+long_select
	phase_select=vimsspec(i,100)+phase_select
	incidence_select=vimsspec(i,101)+incidence_select
	emission_select=vimsspec(i,102)+emission_select
	x=x+1
endfor

vimsspec_select=vimsspec_select/x
lat_select=lat_select/x
long_select=long_select/x
phase_select=phase_select/x
incidence_select=incidence_select/x
emission_select=emission_select/x


num_wavs=size(wavs)




;vims_sp=fltarr(4,96)
;Read in
;close,19
;openr,19,'C:\idl\VIMS_vis\input\VIMS_vis_spectra.txt'
;for i=0,5 do readf,19,str
;readf,19,vims_sp
;close,19
;vims_sp(0,*)=vims_sp(0,*)*1000.
;vims_sp(1,*)=vims_sp(3,*)



;vims_sp=fltarr(2,96)
;Read in
;close,19
;openr,19,'C:\idl\VIMS_vis\input\CM_1540514055_32_01.ren.dat'	; sza=3.5
;openr,19,'C:\idl\VIMS_vis\input\CM_1481501331_31_16.ren.dat'	; sza=40.9
;openr,19,'C:\idl\VIMS_vis\input\CM_1481501331_25_26.ren.dat'	; sza=11.5
;openr,19,'C:\idl\VIMS_vis_Aug2007\idl\input\CM_1481623711_04_01_11.dat'		; sza=43.8,   entry site 2
;openr,19,'C:\idl\VIMS_vis_Aug2007\idl\input\CM_1481624991_12_01_12.dat'		; sza=26.9,   entry site 1
;readf,19,zen
;readf,19,az
;readf,19,str
;readf,19,vims_sp
;close,19
;az=180.-az
;vims_sp(0,*)=vims_sp(0,*)*1000.



; Read the model file
  print,'Starting read of radiative transfer model.'
  read_intensi_ir2,fn,namlist,numg,wavl_model,f0,fdd,fd,fup,fnet,iup,idn, $
    alts,solar_zen_angle,model_zen,model_az
  print,'Radiative transfer model output reading finished.'

  model_alt=alts
  ;model_alt=reform(alts(9:30))
  num_alt=size(model_alt)
  num_wavl=size(wavl_model)
  ;solar_zen_angle=reform(solar_zen_angle(9:30))
  ;fdd=reform(fdd(9:30,*))
  ;fd=reform(fd(9:30,*))
  ;fup=reform(fup(9:30,*))
  ;iup=reform(iup(*,*,9:30,*))
  ;idn=reform(idn(*,*,9:30,*))


intens_temp_up=fltarr(11,31,num_wavl(1))		; (zen, layers, wavl)
intens_up=fltarr(31,num_wavl(1))
intens_temp_down=fltarr(11,31,num_wavl(1))		; (zen, layers, wavl)
intens_down=fltarr(31,num_wavl(1))
int_vims=fltarr(num_wavl(1))						;  wavl


for i=0,num_alt(1)-1 do begin
	for j=0,num_wavl(1)-1 do begin
		for k=0,10 do begin
			intens_temp_up(k,i,j)=interpol(iup(*,k,i,j),model_az,az)
			intens_temp_down(k,i,j)=interpol(idn(*,k,i,j),model_az,az)
		endfor
		intens_up(i,j)=(interpol(intens_temp_up(*,i,j),model_zen,zen))/(f0(j)/!PI)
		intens_down(i,j)=(interpol(intens_temp_down(*,i,j),model_zen,zen))/(f0(j)/!PI)	; f0 at Saturn, change to f0 at Earth
	endfor
endfor



;for i=0,num_wavl(1)-1 do begin
;	int_vims(i)=interpol(vims_sp(1,*),vims_sp(0,*),wavl_model(i))
;endfor

;plot, wavl_model,intens_up(0,*),psym=1,$
;xrange=[500,950]	;, yrange=[0.00,0.25]
;oplot,wavl_model,int_vims,psym=2,  color='ff'X

openw,rotulis,'C:\idl\VIMS_vis_Aug2007\idl\output\I over F output '+fn+'.dat',/get_lun
printf,rotulis, 'Up Intensities'
printf, rotulis,''
printf,rotulis,format="((a10),2(a12))",'wavl','model'
for i=0,num_wavl(1)-1 do begin
   printf,rotulis,format="((f10.2),(f12.5))",wavl_model(i),intens_up(0,i)
endfor
printf,rotulis,''
printf,rotulis,format="((a10),2(a12))",'vims wavl','vims data'
for i=0,num_wavs(1)-1 do begin
   printf,rotulis,format="((f10.2),(f12.5))",wavs(i)*1000.,vimsspec_select(i)
endfor


free_lun,rotulis

print,'model,
print, wavl_model,intens_up(0,*)
;print,'data'
;print, wavs*1000.,vimsspec_select


;for i=0,num_wavl(1)-1 do begin
;	print, wavl_model(i), ((int_vims(i)-intens_up(0,i))/int_vims(i))*100.
;endfor


close,/all

stop
end
